DERExternal (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.asn1

## Class DERExternal

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.ASN1Primitive
    - - org.bouncycastle.asn1.DERExternal

- All Implemented Interfaces:
    ASN1Encodable, Encodable

      public class DERExternal
      extends ASN1Primitive

  Class representing the DER-type External

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DERExternal(ASN1EncodableVector vector)`
    `DERExternal(ASN1ObjectIdentifier directReference, ASN1Integer indirectReference, ASN1Primitive dataValueDescriptor, DERTaggedObject externalData)` Creates a new instance of DERExternal See X.690 for more informations about the meaning of these parameters
    `DERExternal(ASN1ObjectIdentifier directReference, ASN1Integer indirectReference, ASN1Primitive dataValueDescriptor, int encoding, ASN1Primitive externalData)` Creates a new instance of DERExternal.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ASN1Primitive` | `getDataValueDescriptor()` Returns the data value descriptor
    `ASN1ObjectIdentifier` | `getDirectReference()` Returns the direct reference of the external element
    `int` | `getEncoding()` Returns the encoding of the content.
    `ASN1Primitive` | `getExternalContent()` Returns the content of this element
    `ASN1Integer` | `getIndirectReference()` Returns the indirect reference of this element
    `int` | `hashCode()`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Primitive

      `equals, fromByteArray, toASN1Primitive`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `getEncoded, getEncoded, hasEncodedTagValue, toASN1Object`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DERExternal

          public DERExternal(ASN1EncodableVector vector)

    - #### DERExternal

          public DERExternal(ASN1ObjectIdentifier directReference,
                     ASN1Integer indirectReference,
                     ASN1Primitive dataValueDescriptor,
                     DERTaggedObject externalData)

      Creates a new instance of DERExternal See X.690 for more informations about the meaning of these parameters
      Parameters:
        `directReference` - The direct reference or `null` if not set.
        `indirectReference` - The indirect reference or `null` if not set.
        `dataValueDescriptor` - The data value descriptor or `null` if not set.
        `externalData` - The external data in its encoded form.

    - #### DERExternal

          public DERExternal(ASN1ObjectIdentifier directReference,
                     ASN1Integer indirectReference,
                     ASN1Primitive dataValueDescriptor,
                     int encoding,
                     ASN1Primitive externalData)

      Creates a new instance of DERExternal. See X.690 for more informations about the meaning of these parameters
      Parameters:
        `directReference` - The direct reference or `null` if not set.
        `indirectReference` - The indirect reference or `null` if not set.
        `dataValueDescriptor` - The data value descriptor or `null` if not set.
        `encoding` - The encoding to be used for the external data
        `externalData` - The external data

  - ### Method Detail

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `ASN1Primitive`

    - #### getDataValueDescriptor

          public ASN1Primitive getDataValueDescriptor()

      Returns the data value descriptor
      Returns:
        The descriptor

    - #### getDirectReference

          public ASN1ObjectIdentifier getDirectReference()

      Returns the direct reference of the external element
      Returns:
        The reference

    - #### getEncoding

          public int getEncoding()

      Returns the encoding of the content. Valid values are
      - `0` single-ASN1-type
      - `1` OCTET STRING
      - `2` BIT STRING
      Returns:
        The encoding

    - #### getExternalContent

          public ASN1Primitive getExternalContent()

      Returns the content of this element
      Returns:
        The content

    - #### getIndirectReference

          public ASN1Integer getIndirectReference()

      Returns the indirect reference of this element
      Returns:
        The reference